JavaScript/jQuery Calendar - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the Calendar features you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The Calendar component meets a variety of Section 508 and WCAG 2.x compliance standards. Known exceptions:

Section 508 criteria WCAG 2.x criteria Exception description
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
1.3.1 Info and Relationships (Level A) Calendar does not pronounce selected range in multiselect mode.
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
1.4.3 Contrast (Minimum) (Level AA)
1.4.11 Non-text Contrast (Level AA 2.1 and 2.2)
Calendar does not support Windows High Contrast themes.
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
2.4.3 Focus Order (Level A) Calendar does not focus on disabled dates.
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
4.1.2 Name, Role, Value (Level A) The validation state and error message in Calendar are not pronounced after a value change or when the control is focused.

Keyboard Navigation

A user can use the following keys to interact with the Calendar component:

Key Action
← → ↑ ↓ Moves focus to the day nearby.
Page Up or Ctrl + ← Displays the previous month.
Page Down or Ctrl + → Displays the next month.
Enter Selects the focused day.
Ctrl + ↑ Increases zoomLevel.
Ctrl + ↓ Decreases zoomLevel.
Home Moves focus to the first date in the view.
End Moves focus to the last date in the view.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

JavaScript
  • function registerKeyHandlers () {
  • const calendar = $("#calendarContainer").dxCalendar("instance");
  • calendar.registerKeyHandler("backspace", function(e) {
  • // The argument "e" contains information on the event
  • });
  • calendar.registerKeyHandler("space", function(e) {
  • // ...
  • });
  • }

Screen Reader Support

The Calendar component supports screen readers and complies to WAI-ARIA standards.

React Calendar - Accessibility

Accessibility Features Overview

NOTE
The overall accessibility level of your application depends on the Calendar features you use.
Accessibility Requirement Support Level
Right-to-Left Support
Keyboard Navigation Support
Screen Reader Support
Contrast Color Theme
Mobile Device Support
Lighthouse Accessibility Validation
Axe Accessibility Validation
WAVE Accessibility Validation
Section 508 Support
WCAG 2.x Support
  • - All component features meet the requirement
  • - Some component features may not meet the requirement
  • - Accessibility requirement is not supported

Accessibility Standards Compliance

The Calendar component meets a variety of Section 508 and WCAG 2.x compliance standards. Known exceptions:

Section 508 criteria WCAG 2.x criteria Exception description
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
1.3.1 Info and Relationships (Level A) Calendar does not pronounce selected range in multiselect mode.
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
1.4.3 Contrast (Minimum) (Level AA)
1.4.11 Non-text Contrast (Level AA 2.1 and 2.2)
Calendar does not support Windows High Contrast themes.
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
2.4.3 Focus Order (Level A) Calendar does not focus on disabled dates.
501 (Web)(Software)
504.2 (Authoring Tool)
602.3 (Support Docs)
4.1.2 Name, Role, Value (Level A) The validation state and error message in Calendar are not pronounced after a value change or when the control is focused.

Keyboard Navigation

A user can use the following keys to interact with the Calendar component:

Key Action
← → ↑ ↓ Moves focus to the day nearby.
Page Up or Ctrl + ← Displays the previous month.
Page Down or Ctrl + → Displays the next month.
Enter Selects the focused day.
Ctrl + ↑ Increases zoomLevel.
Ctrl + ↓ Decreases zoomLevel.
Home Moves focus to the first date in the view.
End Moves focus to the last date in the view.

Use the registerKeyHandler(key, handler) method to implement a custom handler for a key.

App.js
  • import React from 'react';
  • import 'devextreme/dist/css/dx.light.css';
  •  
  • import { Calendar } from 'devextreme-react/calendar';
  •  
  • class App extends React.Component {
  • constructor(props) {
  • super(props);
  •  
  • this.calendarRef = React.createRef();
  • }
  •  
  • render() {
  • return (
  • <Calendar ref={this.calendarRef} />
  • );
  • }
  •  
  • get calendar() {
  • return this.calendarRef.current.instance();
  • }
  •  
  • componentDidMount() {
  • this.calendar.registerKeyHandler('backspace', function(e) {
  • // The argument "e" contains information on the event
  • });
  • this.calendar.registerKeyHandler('space', function(e) {
  • // ...
  • });
  • }
  • }
  •  
  • export default App;

Screen Reader Support

The Calendar component supports screen readers and complies to WAI-ARIA standards.